package com.ninegag.android.blitz2

/**
 * @param items Delta fetched items
 * @param prevKey Previous key for loading data
 * @param nextKey Next key for loading data
 * @param prependOffset Where should the delta items prepend to
 * @param appendOffset Where should the delta items append to
 */
data class BlitzQueryResult<T, Key>(
        val items: List<T>,
        val prevKey: Key?,
        val nextKey: Key?,
        val prependOffset: Int = 0,
        val appendOffset: Int = 0,
        val listMeta: Map<String, String>? = null
)