package com.under9.android.comments.adapter

import android.view.ViewGroup
import com.ninegag.android.blitz2.adapter.BlitzSubAdapter
import timber.log.Timber

class EmptyCommentAdapter : BlitzSubAdapter<BlitzSubAdapter.ViewHolder>() {

    private var isShown: Boolean = false
    private val emptyCommentRenderer = EmptyViewRenderer()

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): BlitzSubAdapter.ViewHolder {
        Timber.d("")
        return emptyCommentRenderer.onCreateViewHolder(parent, viewType)
    }

    override fun onBindViewHolder(vh: ViewHolder, i: Int) {
        emptyCommentRenderer.show = isShown
        return emptyCommentRenderer.onBindViewHolder(vh, i)
    }

    override fun getItemCount(): Int {
        Timber.d("show=$isShown")
        return if (isShown) {
            1
        } else {
            0
        }
    }

    fun show(show: Boolean) {
        if (isShown == show) return

        this.isShown = show

        if (show) {
            notifyItemInserted(0)
        } else {
            notifyItemRemoved(0)
        }
    }
}