package com.under9.android.comments.api

import com.under9.android.comments.model.api.*

import io.reactivex.Flowable
import retrofit2.adapter.rxjava2.Result
import retrofit2.http.*

interface CommentApiService {

    @FormUrlEncoded
    @POST("/v1/user.json")
    fun getUserStatus(@Field("appId") appId: String): Flowable<Result<ApiUserStatus>>


    @FormUrlEncoded
    @POST("/v1/comment-list.json")
    fun getCommentList(@Field("appId") appId: String,
                       @Field("url") url: String,
                       @Field("order") order: String?,
                       @Field("count") count: Int?,
                       @Field("ref") ref: String?,
                       @Field("refCommentId") refCommentId: String?,
                       @Field("direction") direction: String?,
                       @Field("commentId") commentId: String?): Flowable<Result<ApiCommentList>>

    @FormUrlEncoded
    @POST("/v2/comment-list.json")
    fun getCommentList2(@Field("appId") appId: String,
                        @Field("url") url: String,
                        @Field("count") count: Int?,
                        @Field("commentId") commentId: String?,
                        @Field("type") type: String?,
                        @Field("level") level: Int?,
                        @Field("prev") prev: String?,
                        @Field("next") next: String?): Flowable<Result<ApiCommentList2>>

    @POST("/v1/like.json")
    fun likeComment(@Field("appId") appId: String,
                    @Field("auth") authHash: String,
                    @Field("commentId") commentId: String,
                    @Field("value") value: String): Flowable<Result<ApiResponse>>
}
