package com.under9.android.comments.api

import com.under9.android.comments.data.query.comment.CommentListQueryParam2
import com.under9.android.comments.model.api.ApiCommentList
import com.under9.android.comments.model.api.ApiCommentList2
import com.under9.android.comments.model.api.ApiInfo

import io.reactivex.Flowable
import io.reactivex.Observable
import retrofit2.adapter.rxjava2.Result
import retrofit2.http.GET
import retrofit2.http.Query

interface CommentCdnApiService {

    @GET("/v1/cacheable/comment-list.json")
    fun getCommentList(@Query("appId") appId: String,
                       @Query("url") url: String,
                       @Query("order") order: String?,
                       @Query("count") count: Int?,
                       @Query("ref") ref: String?,
                       @Query("refCommentId") refCommentId: String?,
                       @Query("direction") direction: String?,
                       @Query("commentId") commentId: String?): Flowable<Result<ApiCommentList>>

    @GET("/v2/cacheable/comment-list.json")
    fun getCommentList2(@Query(CommentListQueryParam2.KEY_APP_ID) appId: String,
                        @Query(CommentListQueryParam2.KEY_URL) url: String,
                        @Query(CommentListQueryParam2.KEY_COUNT) count: Int?,
                        @Query(CommentListQueryParam2.KEY_COMMENT_ID) commentId: String?,
                        @Query(CommentListQueryParam2.KEY_TYPE) type: String?,
                        @Query(CommentListQueryParam2.KEY_LEVEL) level: Int?,
                        @Query(CommentListQueryParam2.KEY_PREV) prev: String?,
                        @Query(CommentListQueryParam2.KEY_NEXT) next: String?): Flowable<Result<ApiCommentList2>>

    @GET("/v1/cacheable/app.json")
    fun getAppInfo(@Query("id") appId: String): Flowable<Result<ApiInfo>>
}
