package com.under9.android.comments.controller

class CommentQuotaChecker(
        private val commentSystemController: CommentSystemController
) {

    /**
     * Check quota with error message
     */
    fun checkQuota(): String? {
        return if (!hasQuota() && !commentSystemController.isCommentQuotaDataExpired) {
            MetricsController.logApiNoQuota("checkQuota failed: " + commentSystemController.commentQuota + " - " + commentSystemController.commentQuotaWaitUntil)
            val msg = commentSystemController.quotaWaitMessage
            commentSystemController.refreshInfo()
            msg
        } else {
            null
        }
    }

    private fun hasQuota(): Boolean {
        return commentSystemController.commentQuota > 0
    }
}