package com.under9.android.comments.data.query.comment

import com.ninegag.android.blitz2.DataSource

/**
 * @see https://tools.9gaginc.com/apidoc/9gag/comment.html#/Comment/get_v2_cacheable_comment_list_json
 */
data class CommentListQueryParam2(
        val isRefresh: Boolean,
        val direction: Int,
        val listKey: String,
        val url: String,
        val type: String?, // old, new, hot (parent comment only)
        val count: Int = DEFAULT_COUNT,
        val commentId: String?,
        val level: Int? = null, // Integer actually, but when calling children, it's not needed
        val prev: String?,
        val next: String?,
        val localNextOffset: Int = 0
): DataSource.QueryParam {
    companion object {
        const val KEY_APP_ID = "appId"
        const val KEY_URL = "url"
        const val KEY_COUNT = "count"
        const val KEY_COMMENT_ID = "commentId"
        const val KEY_TYPE = "type"
        const val KEY_LEVEL = "level"
        const val KEY_PREV = "prev"
        const val KEY_NEXT = "next"

        const val TYPE_HOT = "hot"
        const val TYPE_OLD = "old"
        const val TYPE_NEW = "new"

        const val DIRECTION_NEXT = 0
        const val DIRECTION_PREV = 1

        const val DEFAULT_COUNT = 10
        const val DEFAULT_TYPE = TYPE_HOT


        // Refer to:
        // https://docs.google.com/spreadsheets/d/1ELHHlRXQJdgtBsLjofWNuMH7AkQNmSxapfeoTyD-Zik/edit#gid=0
        const val LOAD_TYPE_OLD = 0 // ?type=old
        const val LOAD_TYPE_NEW = 1 // ?type=new
        const val LOAD_TYPE_HOT = 2 // ?type=hot

        const val LOAD_TYPE_LINKED_COMMENT = 5 // ?type=hot&commentId=c_070
        const val LOAD_TYPE_THREAD = 6 // ?commentId=c_088&level=2 (Open replies)

        const val LOAD_TYPE_RESTORE_POSITION_FIRST_LEVEL = 3 // ?commentId=c_406 (default type: old)
        const val LOAD_TYPE_RESTORE_POSITION_FIRST_LEVEL_NEW = 4 // ?type=new&commentId=c_026
    }
}