package com.under9.android.comments.helper

object CommentListHelper {
    @JvmStatic fun formatListKey(url: String,
                                 commentId: String? = null,
                                 level: Int?): String {

        var base = url

        if (commentId != null) {
            base = "$base#cs_comment_id=$commentId"
        }

        if (level != null) {
            base = "$base:$level"
        }

        return base
    }

    @JvmStatic fun formatCombinedCursor(remoteCursor: String?, localOffset: Int): String = "$remoteCursor:$localOffset"

    @JvmStatic fun parseCombinedCursor(combinedCursor: String): Pair<String?, Int> {
        val cursor = combinedCursor.split(":")
        return Pair(if (cursor[0] == "null") null else cursor[0], cursor[1].toInt())
    }
}