package com.under9.android.comments.model.wrapper

import android.text.Spanned
import com.under9.android.comments.data.query.comment.CommentListQueryParam2
import com.under9.android.comments.model.api.MediaData

interface CommentItemWrapperInterface {
    var likeStatus: Int
    var isOP: Boolean

    var likeCount: Int
    var dislikeCount: Int

    /**
     * Comment's status
     */
    var status: Int

    var prevUrl: String?

    fun getId(): Long
    fun getCommentId(): String
    fun isMyComment(): Boolean

    fun shouldHighlight(): Boolean
    fun getTime(): Long
    fun isPending(): Boolean

    // FIXME: 2019-08-09 Should abstract all DAO implementaiton
    // getComment()
    fun getMentionedAccountId(username: String): String?
    fun getMentionedUserMap(): Map<String, String>

    /**
     * The url of an object which current comment is attached to
     */
    fun getAttachedToUrl(): String
    fun getPermalink(): String
    fun getShareUrl(): String
    fun getLevel(): Int

    fun getContent(): Spanned?
    fun getRawText(): String?

    fun getType(): Int

    fun getCommentLabel(): String

    fun getUser(): UserItemWrapperInterface

    fun getChildrenTotal(): Int
    fun getChildrenUrl(): String?
    fun getChildCommentListQueryParam(): CommentListQueryParam2?

    fun getMediaList(): Array<MediaData>?

    fun getFirstMedia(): MediaData?

    fun isParent(): Boolean

    fun refresh()
}