package com.under9.android.comments.model.wrapper

import android.content.Context
import com.under9.android.comments.model.User
import com.under9.android.commentsystem.R
import com.under9.android.lib.util.L10nUtil

class PendingUserWrapper(
        private val user: User?,
        private val context: Context
) : UserItemWrapperInterface {

    override fun getUserId(): String = user?.userId ?: ""

    override fun getAccountId(): String = user?.accountId ?: ""

    override fun getName(): String = user?.displayName ?: context.getString(R.string.me)

    override fun getEmojiStatus(): String = user?.emojiStatus ?: ""

    override fun getCountryEmoji(): String {
        if (user == null) return ""
        return L10nUtil.countryCodeToEmoji(user.country) ?: ""
    }

    override fun getAvatarUrl(): String = user?.avatarUrl ?: "https://"

    override fun isPro(): Boolean = user?.isActivePro ?: false

    override fun isProPlus(): Boolean = user?.isActiveProPlus ?: false

    override fun isActive(): Boolean = true

    override fun getDisplayName(): String = user?.displayName ?: ""
}