package com.under9.android.comments.ui.fragment.dialog

import android.content.Context
import com.under9.android.commentsystem.R
import com.under9.android.lib.bottomsheet.BottomSheet.TYPE_SIMPLE
import com.under9.android.lib.bottomsheet.BottomSheetModel
import com.under9.android.lib.bottomsheet.data.BottomSheetMenuItemsV2

object CommentBottomSheetBuilderV2 {

    @JvmStatic
    fun buildActionTextSheet(isOp: Boolean, isCommentCreator: Boolean, context: Context): BottomSheetMenuItemsV2 {
        val actionItems = ArrayList<BottomSheetModel>()

        with(context) {

            var reportCommentIndex = 0
            var deleteCommentIndex = 0
            val taTitle = context.resources.obtainTypedArray(R.array.cs_actionSheetTitles)
            val taIcon = context.resources.obtainTypedArray(R.array.cs_actionSheetIcons)
            val taId = context.resources.obtainTypedArray(R.array.cs_actionSheetIds)
            for (i in 0 until taId.length()) {
                if (taId.getResourceId(i, -1) == R.id.action_report_comment) {
                    reportCommentIndex = i
                } else if (taId.getResourceId(i, -1) == R.id.action_delete_comment) {
                    deleteCommentIndex = i
                }

                actionItems.add(BottomSheetModel(
                        title = getString(taTitle.getResourceId(i, -1)),
                        id = taId.getResourceId(i, -1),
                        iconRes = taIcon.getResourceId(i, -1),
                        displayType = TYPE_SIMPLE
                ))
            }

            if (isOp || isCommentCreator) {
                actionItems.removeAt(reportCommentIndex)
            } else {
                actionItems.removeAt(deleteCommentIndex)
            }

            taTitle.recycle()
            taIcon.recycle()
            taId.recycle()
        }
        return BottomSheetMenuItemsV2(actionItems)
    }

    @JvmStatic
    fun buildActionMediaSheet(context: Context): BottomSheetMenuItemsV2 {
        val actionItems = ArrayList<BottomSheetModel>()
        with(context) {

            val taTitle = context.resources.obtainTypedArray(R.array.cs_actionSheetMediaTitles)
            val taIcon = context.resources.obtainTypedArray(R.array.cs_actionSheetMediaIcons)
            val taId = context.resources.obtainTypedArray(R.array.cs_actionSheetMediaIds)
            for (i in 0 until taId.length()) {
                actionItems.add(BottomSheetModel(
                        title = getString(taTitle.getResourceId(i, -1)),
                        id = taId.getResourceId(i, -1),
                        iconRes = taIcon.getResourceId(i, -1),
                        displayType = TYPE_SIMPLE
                ))
            }
            taTitle.recycle()
            taIcon.recycle()
            taId.recycle()
        }
        return BottomSheetMenuItemsV2(actionItems)
    }

}