package com.under9.android.lib.bottomsheet

import android.graphics.PorterDuff
import android.os.Parcelable
import android.widget.ImageView
import androidx.core.graphics.drawable.DrawableCompat
import com.under9.android.lib.widget.R
import kotlinx.android.parcel.Parcelize


object BottomSheet {
    @JvmStatic
    val TYPE_ACCOUNT = R.id.bottom_sheet_type_account

    @JvmStatic
    val TYPE_BADGE = R.id.bottom_sheet_type_badge

    @JvmStatic
    val TYPE_SWITCH = R.id.bottom_sheet_type_switch

    @JvmStatic
    val TYPE_SIMPLE = R.id.bottom_sheet_type_simple

    @JvmStatic
    val TYPE_DIVIDER = R.id.bottom_sheet_divider
}

@Parcelize
data class BottomSheetModel(
        val title: String = "",
        val iconRes: Int = 0,
        val id: Int = 0,
        val displayType: Int = 0,
        val additionalBooleanInfo: Boolean? = null,
        val additionalStringInfo: String? = null,
        val additionalIconColor: Int = -1
) : Parcelable

@Parcelize
data class BottomSheetGroup(val models: List<BottomSheetModel>): Parcelable

fun ImageView.applyTintColor(color: Int) {
    var d = this.drawable
    d.mutate()
    d = DrawableCompat.wrap(d)

    DrawableCompat.setTint(d, color)
    DrawableCompat.setTintMode(d, PorterDuff.Mode.SRC_IN)
}